<?php
    namespace App\Services;

    class NetLicensingService
    {
        const BASE_URL = 'https://go.netlicensing.io/core/v2/rest';
        const SECURITY_MODE = \NetLicensing\Constants::BASIC_AUTHENTICATION;
        const USERNAME = 'desarrollo@inovul.com';
        const PASSWORD = 'KrrbU3D92jA7EqG';

        // private $faker;

        private $context;
        /** @var  \NetLicensing\Product */
        private $product;
        /** @var  \NetLicensing\ProductModule */
        private $productModule;
        /** @var  \NetLicensing\LicenseTemplate */
        private $licenseeTemplate;
        /** @var  \NetLicensing\Licensee */
        private $licensee;
        /** @var  \NetLicensing\License */
        private $license;
        /** @var  \NetLicensing\Transaction */
        private $transaction;
        /** @var  \NetLicensing\Token */
        private $token;

        protected $statuses = [];

        public static function run()
        {
            return new NetLicensingService();
        }


        public function __construct()
        {
            // $this->faker = Faker\Factory::create();

            $this->setUpContext();

            //UtilityService
            // \cli\line('---------------------------- UtilityService ----------------------------');
            // $this->listLicenseTypes();
            // $this->listLicenseModels();
            // $this->listCountries();

            //ProductService
            // \cli\line('---------------------------- ProductService ----------------------------');
            // $this->createProduct();
            // $this->getProduct();
            // $this->updateProduct();
            // $this->listProduct();

            //ProductService
            // \cli\line('---------------------------- ProductModuleService ----------------------------');
            // $this->createProductModule();
            // $this->getProductModule();
            // $this->updateProductModule();
            // $this->listProductModule();

            //LicenseTemplateService
            // \cli\line('---------------------------- LicenseTemplateService ----------------------------');
            // $this->createLicenseTemplate();
            // $this->getLicenseTemplate();
            // $this->updateLicenseTemplate();
            // $this->listLicenseTemplate();

            //LicenseeService
            // \cli\line('---------------------------- LicenseeService ----------------------------');
            // $this->createLicensee();
            // $this->getLicensee();
            // $this->updateLicensee();
            // $this->listLicensee();

            //LicenseService
            // \cli\line('---------------------------- LicenseService ----------------------------');
            // $this->createLicense();
            // $this->getLicense();
            // $this->updateLicense();
            // $this->listLicense();

            //LicenseeService
            // \cli\line('---------------------------- VALIDATE ----------------------------');
            // $this->validate();

            //LicenseeService
            // \cli\line('---------------------------- TRANSFER ----------------------------');
            // $this->transfer();

            //TransactionService
            // \cli\line('---------------------------- TransactionService ----------------------------');
            // $this->createTransaction();
            // $this->getTransaction();
            // $this->updateTransaction();
            // $this->listTransaction();

            //TokenService
            // \cli\line('---------------------------- TokenService ----------------------------');
            // $this->createToken();
            // $this->getToken();
            // $this->listToken();

            //PaymentMethodService
            // \cli\line('---------------------------- PaymentMethodService ----------------------------');
            // $this->getPaymentMethod();
            // $this->listPaymentMethod();

            //Cleanup
            // \cli\line('---------------------------- Cleanup ----------------------------');
            // $this->deleteToken();
            // $this->deleteLicense();
            // $this->deleteLicensee();
            // $this->deleteLicenseTemplate();
            // $this->deleteProductModule();
            // $this->deleteProduct();

            //Cleanup
            // \cli\line('---------------------------- Statuses ----------------------------');
            // $this->statuses();
        }

        /**
         * Determines the vendor on whose behalf the call is performed
         *
         * @return \NetLicensing\Context
         */
        public function setUpContext()
        {
            return $this->context = (new \NetLicensing\Context())
                ->setBaseUrl(self::BASE_URL)
                ->setSecurityMode(self::SECURITY_MODE)
                ->setUsername(self::USERNAME)
                ->setPassword(self::PASSWORD);
        }

        public function listLicenseTypes()
        {
            try {
                $licenseTypes = \NetLicensing\UtilityService::listLicenseTypes($this->context);

                $headers = ['License Types'];

                $rows = [];

                foreach ($licenseTypes as $licenseType) {
                    $rows[] = [$licenseType['name']];
                }
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listLicenseModels()
        {
            try {

                $licensingModels = \NetLicensing\UtilityService::listLicensingModels($this->context);

                $headers = ['Licensing Models'];

                $rows = [];

                foreach ($licensingModels as $licensingModel) {
                    $rows[] = [$licensingModel['name']];
                }
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listCountries()
        {
            try {

                $countries = \NetLicensing\UtilityService::listCountries($this->context);

                $headers = ['Code', 'Name', 'Vat Percent', 'Is Eu'];

                $rows = [];
                /** @var  $country \NetLicensing\Country */
                foreach ($countries as $country) {
                    $rows[] = [
                        $country->getCode(),
                        $country->getName(),
                        $country->getVatPercent(),
                        $country->getIsEu(),
                    ];
                }
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }


        public function createProduct()
        {
            try {
                $product = new \NetLicensing\Product();

                // $product->setNumber($this->faker->bothify('P-########'));
                // $product->setName($this->faker->sentence(6, true));
                $product->setActive(true);
                // $product->setVersion($this->faker->randomFloat(2));
                // $product->setLicenseeAutoCreate($this->faker->boolean(70));

                $discount = new \NetLicensing\ProductDiscount();
                // $discount->setTotalPrice($this->faker->randomFloat(2, 10, 50));
                $discount->setCurrency('EUR');
                // $discount->setAmountPercent($this->faker->numberBetween(0, 90));

                $product->addDiscount($discount);

                $this->product = \NetLicensing\ProductService::create($this->context, $product);

                //output
                $headers = ['Number', 'Name', 'Active', 'Licensee Auto Create', 'Discounts'];
                $rows[] = [
                    $this->product->getNumber(),
                    $this->product->getName(),
                    ($this->product->getActive()) ? 'true' : 'false',
                    ($this->product->getLicenseeAutoCreate()) ? 'true' : 'false',
                    $this->discountsOutput($this->product->getProductDiscounts())
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function getProduct()
        {
            try {

                if (!$this->product) throw new Exception('Product not found');

                $this->product = \NetLicensing\ProductService::get($this->context, $this->product->getNumber());

                //output
                $headers = ['Number', 'Name', 'Active', 'Licensee Auto Create', 'Discounts'];

                $rows[] = [
                    $this->product->getNumber(),
                    $this->product->getName(),
                    ($this->product->getActive()) ? 'true' : 'false',
                    ($this->product->getLicenseeAutoCreate()) ? 'true' : 'false',
                    $this->discountsOutput($this->product->getProductDiscounts())
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;

            }
        }

        public function listProduct()
        {
            try {

                $products = \NetLicensing\ProductService::getList($this->context);

                $headers = ['Number', 'Name', 'Active', 'Licensee Auto Create', 'Discounts'];

                $rows = [];

                /** @var  $product \NetLicensing\Product */
                foreach ($products as $product) {

                    $rows[] = [
                        $product->getNumber(),
                        $product->getName(),
                        ($product->getActive()) ? 'true' : 'false',
                        ($product->getLicenseeAutoCreate()) ? 'true' : 'false',
                        $this->discountsOutput($product->getProductDiscounts())
                    ];
                    return $rows;
                }

                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function updateProduct()
        {
            try {

                if (!$this->product) throw new Exception('Product not found');

                $number = $this->product->getNumber();

                // $this->product->setNumber($this->faker->bothify('P-########'));
                // $this->product->setName($this->faker->sentence(6, true));
                // $this->product->setVersion($this->faker->randomFloat(2));
                // $this->product->setLicenseeAutoCreate($this->faker->boolean(70));

                $this->product = \NetLicensing\ProductService::update($this->context, $number, $this->product);

                //output
                $headers = ['Number', 'Name', 'Active', 'Licensee Auto Create', 'Discounts'];
                $rows[] = [
                    $this->product->getNumber(),
                    $this->product->getName(),
                    ($this->product->getActive()) ? 'true' : 'false',
                    ($this->product->getLicenseeAutoCreate()) ? 'true' : 'false',
                    $this->discountsOutput($this->product->getProductDiscounts())
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function deleteProduct()
        {
            try {

                if (!$this->product) throw new Exception('Product not found');

                NetLicensing\ProductService::delete($this->context, $this->product->getNumber());

                //output
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function createProductModule()
        {
            try {

                if (!$this->product) throw new Exception('Product not found');

                $productModule = new \NetLicensing\ProductModule();
                // $productModule->setNumber($this->faker->bothify('PM-########'));
                // $productModule->setName($this->faker->sentence(6, true));
                $productModule->setActive(true);
                $productModule->setLicensingModel('Subscription');

                $this->productModule = NetLicensing\ProductModuleService::create($this->context, $this->product->getNumber(), $productModule);

                //output
                $headers = ['Number', 'Name', 'Active', 'LicensingModel'];
                $rows[] = [
                    $this->productModule->getNumber(),
                    $this->productModule->getName(),
                    ($this->productModule->getActive()) ? 'true' : 'false',
                    $this->productModule->getLicensingModel()
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function getProductModule()
        {
            try {

                if (!$this->productModule) throw new Exception('ProductModule not found');

                $this->productModule = \NetLicensing\ProductModuleService::get($this->context, $this->productModule->getNumber());

                //output
                $headers = ['Number', 'Name', 'Active', 'LicensingModel'];

                $rows[] = [
                    $this->productModule->getNumber(),
                    $this->productModule->getName(),
                    ($this->productModule->getActive()) ? 'true' : 'false',
                    $this->productModule->getLicensingModel()
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listProductModule()
        {
            try {

                $productModules = \NetLicensing\ProductModuleService::getList($this->context);

                $headers = ['Number', 'Name', 'Active', 'LicensingModel'];

                $rows = [];

                /** @var  $productModule \NetLicensing\ProductModule */
                foreach ($productModules as $productModule) {

                    $rows[] = [
                        $productModule->getNumber(),
                        $productModule->getName(),
                        ($productModule->getActive()) ? 'true' : 'false',
                        $productModule->getLicensingModel(),
                        $productModule->getProductNumber()
                    ];
                }

                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function updateProductModule()
        {
            try {
                if (!$this->productModule) throw new Exception('ProductModule not found');

                $number = $this->productModule->getNumber();

                // $this->productModule->setName($this->faker->sentence(6, true));

                $this->productModule = \NetLicensing\ProductModuleService::update($this->context, $number, $this->productModule);

                //output
                $headers = ['Number', 'Name', 'Active', 'LicensingModel'];
                $rows[] = [
                    $this->productModule->getNumber(),
                    $this->productModule->getName(),
                    ($this->productModule->getActive()) ? 'true' : 'false',
                    $this->productModule->getLicensingModel()
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function deleteProductModule()
        {
            try {

                if (!$this->productModule) throw new Exception('ProductModule not found');

                NetLicensing\ProductModuleService::delete($this->context, $this->productModule->getNumber());

                //output
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function createLicenseTemplate()
        {
            try {

                $licenseTemplate = new \NetLicensing\LicenseTemplate();
                // $licenseTemplate->setNumber($this->faker->bothify('LT-########'));
                // $licenseTemplate->setName($this->faker->sentence(6, true));
                $licenseTemplate->setActive(true);
                $licenseTemplate->setLicenseType('TIMEVOLUME');
                $licenseTemplate->setTimeVolume(30);
                // $licenseTemplate->setPrice($this->faker->randomFloat(2, 0, 100));
                $licenseTemplate->setCurrency('EUR');

                $this->licenseeTemplate = NetLicensing\LicenseTemplateService::create($this->context, $this->productModule->getNumber(), $licenseTemplate);

                //output
                $headers = ['Number', 'Name', 'Active', 'LicenseType', 'Price', 'Currency'];
                $rows[] = [
                    $this->licenseeTemplate->getNumber(),
                    $this->licenseeTemplate->getName(),
                    ($this->licenseeTemplate->getActive()) ? 'true' : 'false',
                    $this->licenseeTemplate->getLicenseType(),
                    $this->licenseeTemplate->getPrice(),
                    $this->licenseeTemplate->getCurrency(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function getLicenseTemplate($licenseeTemplateNumber)
        {
            try {

                // if (!$this->licenseeTemplate) throw new Exception('LicenseeTemplate not found');

                // second parameter $this->licenseeTemplate->getNumber()
                $this->licenseeTemplate = \NetLicensing\LicenseTemplateService::get($this->context, $licenseeTemplateNumber);

                //output
                $headers = ['Number', 'Name', 'Active', 'LicenseType', 'Price', 'Currency'];
                $rows[] = [
                    $this->licenseeTemplate->getNumber(),
                    $this->licenseeTemplate->getName(),
                    ($this->licenseeTemplate->getActive()) ? 'true' : 'false',
                    $this->licenseeTemplate->getLicenseType(),
                    $this->licenseeTemplate->getPrice(),
                    $this->licenseeTemplate->getCurrency(),
                    $this->licenseeTemplate->getActionUrl()
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listLicenseTemplate()
        {
            try {

                $licenseTemplates = \NetLicensing\LicenseTemplateService::getList($this->context);

                $headers = ['Number', 'Name', 'Active', 'LicenseType', 'Price', 'Currency'];

                $rows = [];

                /** @var  $licenseTemplate \NetLicensing\LicenseTemplate */
                foreach ($licenseTemplates as $licenseTemplate) {

                    $rows[] = [
                        $licenseTemplate->getNumber(),
                        $licenseTemplate->getName(),
                        ($licenseTemplate->getActive()) ? 'true' : 'false',
                        $licenseTemplate->getLicenseType(),
                        $licenseTemplate->getPrice(),
                        $licenseTemplate->getCurrency(),
                        $licenseTemplate->getProductModuleNumber(),
                        $licenseTemplate->getActionUrl()
                    ];
                }
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function updateLicenseTemplate($licenseTemplateNumber, $active)
        {
            try {

                // if (!$this->licenseeTemplate) throw new Exception('LicenseeTemplate not found');
                $licenseTemplate = new \NetLicensing\LicenseTemplate();

                // $this->licenseeTemplate->setName($this->faker->sentence(6, true));
                // $this->licenseeTemplate->setPrice($this->faker->randomFloat(2, 0, 100));
                $licenseTemplate->setActive($active);

                // second parameter $this->licenseeTemplate->getNumber()
                $this->licenseeTemplate = \NetLicensing\LicenseTemplateService::update($this->context, $licenseTemplateNumber, $licenseTemplate);

                //output
                $headers = ['Number', 'Name', 'Active', 'LicenseType', 'Price', 'Currency'];
                $rows[] = [
                    $this->licenseeTemplate->getNumber(),
                    $this->licenseeTemplate->getName(),
                    ($this->licenseeTemplate->getActive()) ? 'true' : 'false',
                    $this->licenseeTemplate->getLicenseType(),
                    $this->licenseeTemplate->getPrice(),
                    $this->licenseeTemplate->getCurrency(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function deleteLicenseTemplate()
        {
            try {

                if (!$this->licenseeTemplate) throw new Exception('LicenseeTemplate not found');

                NetLicensing\LicenseTemplateService::delete($this->context, $this->licenseeTemplate->getNumber());

                //output
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function createLicensee()
        {
            try {
                $licensee = new \NetLicensing\Licensee();
                // $licensee->setNumber($this->faker->bothify('L-########'));
                // $licensee->setName($this->faker->sentence(6, true));
                // $licensee->setActive(true);

                // second parameter $this->product->getNumber()
                $this->licensee = \NetLicensing\LicenseeService::create($this->context, 'P7JHQNUGE', $licensee);

                //output
                $headers = ['Number', 'Name', 'Active'];
                $rows[] = [
                    $this->licensee->getNumber(),
                    $this->licensee->getName(),
                    ($this->licensee->getActive()) ? 'true' : 'false',
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        // test create license princing table
        public function createLicenseePrincingTable($product_number)
        {
            try {
                $licensee = new \NetLicensing\Licensee();
                // $licensee->setNumber($this->faker->bothify('L-########'));
                // $licensee->setName($this->faker->sentence(6, true));
                // $licensee->setActive(true);

                // second parameter $this->product->getNumber()
                $this->licensee = \NetLicensing\LicenseeService::create($this->context, $product_number, $licensee);

                //output
                $headers = ['Number', 'Name', 'Active'];
                $rows[] = [
                    $this->licensee->getNumber(),
                    $this->licensee->getName(),
                    ($this->licensee->getActive()) ? 'true' : 'false',
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function getLicensee($lcs_number)
        {
            try {

                // if (!$this->licensee) throw new Exception('Licensee not found');

                // second parameter is number licensee
                $this->licensee = \NetLicensing\LicenseeService::get($this->context, $lcs_number);

                //output
                // $headers = ['Number', 'Name', 'Active'];
                // $rows[] = [
                    // $this->licensee->getNumber(),
                    // $this->licensee->getName(),
                    // ($this->licensee->getActive()) ? 'true' : 'false',
                // ];
                // return $rows;
                return $this->licensee;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listLicensee()
        {
            try {

                $licensees = \NetLicensing\LicenseeService::getList($this->context);

                // $headers = ['Number', 'Name', 'Active'];

                // $rows = [];

                /** @var  $licensee \NetLicensing\Licensee */
                // foreach ($licensees as $licensee) {

                    // $rows[] = [
                        // $licensee->getNumber(),
                        // $licensee->getName(),
                        // ($licensee->getActive()) ? 'true' : 'false',
                    // ];
                // }
                // return $rows;

                return $licensees;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function updateLicensee()
        {
            try {

                if (!$this->licensee) throw new Exception('Licensee not found');

                // $this->licensee->setName($this->faker->sentence(6, true));

                $this->licensee = NetLicensing\LicenseeService::update($this->context, $this->licensee->getNumber(), $this->licensee);

                //output
                $headers = ['Number', 'Name', 'Active'];
                $rows[] = [
                    $this->licensee->getNumber(),
                    $this->licensee->getName(),
                    ($this->licensee->getActive()) ? 'true' : 'false',
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function deleteLicensee($lcs_number)
        {
            try {

                // if (!$this->licensee) throw new Exception('Licensee not found');

                // second parameter $this->licensee->getNumber()
                // third parameter is a booelan for forceCascade
                \NetLicensing\LicenseeService::delete($this->context, $lcs_number, true);

                //output
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function validate()
        {
            try {
                $validationParameters = new \NetLicensing\ValidationParameters();
                // $validationParameters->setLicenseeName($this->faker->uuid);
                // $validationParameters->setProductNumber($this->product->getNumber());
                // $validationParameters->setLicenseeName($this->licensee->getName());

                $validationParameters->setProductNumber('PVZTZZ4TT');
                $validationParameters->setLicenseeName('IRIQZXWXN');

                // second parameter
                // $this->licensee->getNumber()
                $validationResult = \NetLicensing\LicenseeService::validate($this->context, 'IRIQZXWXN', $validationParameters);

                // $validation = $validationResult->getProductModuleValidation($this->productModule->getNumber());
                $validation = $validationResult->getProductModuleValidation('MDXDTE2TS');

                //output
                $headers = ['Product Module Number', 'Product Module Name', 'Licensing Model', 'Valid'];
                $rows[] = [
                    $validation['productModuleNumber'],
                    $validation['productModuleName'],
                    $validation['licensingModel'],
                    ($validation['valid']) ? 'true' : 'false',
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function transfer()
        {
            try {

                $licensee = new \NetLicensing\Licensee();
                // $licensee->setNumber($this->faker->bothify('L-########'));
                // $licensee->setName($this->faker->sentence(6, true));
                $licensee->setActive(true);

                $licensee = \NetLicensing\LicenseeService::create($this->context, $this->product->getNumber(), $licensee);

                $this->licensee->setMarkedForTransfer(true);

                $this->licensee = \NetLicensing\LicenseeService::update($this->context, $this->licensee->getNumber(), $this->licensee);

                \NetLicensing\LicenseeService::transfer($this->context, $licensee->getNumber(), $this->licensee->getNumber());

                $this->licensee = $licensee;

                //output
                $headers = ['Number', 'Name', 'Active'];
                $rows[] = [
                    $this->licensee->getNumber(),
                    $this->licensee->getName(),
                    ($this->licensee->getActive()) ? 'true' : 'false',
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function createLicense($numberLicensee, $licenseTemplateNumber)
        {
            try {
                $license = new \NetLicensing\License();
                // $license->setNumber($this->faker->bothify('LC-########'));
                // $license->setName($this->faker->sentence(6, true));
                $license->setStartDate('now');
                $license->setActive(true);

                // second parameter $this->licensee->getNumber()
                // third parameter $this->licenseeTemplate->getNumber()
                $this->license = \NetLicensing\LicenseService::create($this->context, $numberLicensee, $licenseTemplateNumber, null, $license);

                //output
                $headers = ['Number', 'Name'];
                $rows[] = [
                    $this->license->getNumber(),
                    $this->license->getName(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function getLicense($lcsnum)
        {
            try {

                if (!$lcsnum) throw new Exception('License not found');

                $this->license = NetLicensing\LicenseService::get($this->context, $lcsnum);

                //output
                $headers = ['Number', 'Name'];
                $rows[] = [
                    $this->license->getNumber(),
                    $this->license->getName(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listLicense()
        {
            try {

                $licenses = \NetLicensing\LicenseService::getList($this->context);

                // $headers = ['Number', 'Name'];

                $rows = [];

                /** @var  $license \NetLicensing\License */
                foreach ($licenses as $license) {

                    $rows[] = [
                        $license->getNumber(),
                        $license->getName(),
                    ];
                }
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function updateLicense()
        {
            try {

                if (!$this->license) throw new Exception('License not found');

                // $this->license->setName($this->faker->sentence(6, true));

                $this->license = NetLicensing\LicenseService::update($this->context, $this->license->getNumber(), null, $this->license);

                //output
                $headers = ['Number', 'Name'];
                $rows[] = [
                    $this->license->getNumber(),
                    $this->license->getName(),
                ];
                return rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function deleteLicense()
        {
            try {

                if (!$this->license) throw new Exception('License not found');

                NetLicensing\LicenseService::delete($this->context, $this->license->getNumber());

                //output
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function createTransaction()
        {
            try {

                $transaction = new \NetLicensing\Transaction();
                // $transaction->setNumber($this->faker->bothify('TR-########'));
                $transaction->setStatus('PENDING');
                $transaction->setSource('SHOP');

                $this->transaction = \NetLicensing\TransactionService::create($this->context, $transaction);

                //output
                $headers = ['Number', 'Status'];
                $rows[] = [
                    $this->transaction->getNumber(),
                    $this->transaction->getStatus(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function getTransaction()
        {
            try {

                if (!$this->transaction) throw new Exception('Transaction not found');

                $this->transaction = NetLicensing\TransactionService::get($this->context, $this->transaction->getNumber());

                //output
                $headers = ['Number', 'Status'];
                $rows[] = [
                    $this->transaction->getNumber(),
                    $this->transaction->getStatus(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listTransaction()
        {
            try {

                $transactions = \NetLicensing\TransactionService::getList($this->context);

                $headers = ['Number', 'Status'];

                $rows = [];

                /** @var  $transaction \NetLicensing\Transaction */
                foreach ($transactions as $transaction) {

                    $rows[] = [
                        $transaction->getNumber(),
                        $transaction->getStatus(),
                    ];
                }
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function updateTransaction()
        {
            try {

                if (!$this->transaction) throw new Exception('Transaction not found');

                $this->transaction->setStatus('CLOSED');

                $this->transaction = NetLicensing\TransactionService::update($this->context, $this->transaction->getNumber(), $this->transaction);

                //output
                $headers = ['Number', 'Status'];
                $rows[] = [
                    $this->transaction->getNumber(),
                    $this->transaction->getStatus(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function createToken()
        {
            try {

                $token = new \NetLicensing\Token();
                // $token->setNumber($this->faker->bothify('T-########'));
                $token->setTokenType('SHOP');
                $token->setLicenseeNumber($this->licensee->getNumber());

                $this->token = \NetLicensing\TokenService::create($this->context, $token);

                //output
                $headers = ['Number', 'Type', 'Expiration Time'];
                $rows[] = [
                    $this->token->getNumber(),
                    $this->token->getTokenType(),
                    $this->token->getExpirationTime(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function getToken()
        {
            try {

                if (!$this->token) throw new Exception('Token not found');

                $this->token = NetLicensing\TokenService::get($this->context, $this->token->getNumber());

                //output
                $headers = ['Number', 'Type', 'Expiration Time'];
                $rows[] = [
                    $this->token->getNumber(),
                    $this->token->getTokenType(),
                    $this->token->getExpirationTime(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listToken()
        {
            try {

                $tokens = \NetLicensing\TokenService::getList($this->context);

                $headers = ['Number', 'Type', 'Expiration Time'];

                $rows = [];

                /** @var  $token \NetLicensing\Token */
                foreach ($tokens as $token) {

                    $rows[] = [
                        $token->getNumber(),
                        $token->getTokenType(),
                        $token->getExpirationTime(),
                    ];
                }
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function deleteToken()
        {
            try {

                if (!$this->token) throw new Exception('Token not found');

                NetLicensing\TokenService::delete($this->context, $this->token->getNumber());

                //output
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function getPaymentMethod()
        {
            try {
                $paymentMethod = NetLicensing\PaymentMethodService::get($this->context, 'PAYPAL');

                //output
                $headers = ['Number'];
                $rows[] = [
                    $paymentMethod->getNumber(),
                ];
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        public function listPaymentMethod()
        {
            try {
                $paymentMethods = NetLicensing\PaymentMethodService::getList($this->context);

                //output
                $headers = ['Number'];

                $rows = [];

                /** @var  $paymentMethod \NetLicensing\PaymentMethod */
                foreach ($paymentMethods as $paymentMethod) {

                    $rows[] = [
                        $paymentMethod->getNumber(),
                    ];
                }
                return $rows;
                
            } catch (Exception $exception) {
                //output
                return $exception;
            }
        }

        private function statuses()
        {

            $headers = ['Operation', 'Status', 'Message'];
            asort($this->statuses);
        }

        private function discountsOutput($discounts)
        {
            $output = '';

            foreach ($discounts as $discount) {
                $output .= (string)$discount . " ";
            }

            return $output;
        }

        // private function success($apiMethod)
        // {
            // \cli\line($apiMethod . ' - OK');

            // $this->statuses[$apiMethod] = [$apiMethod, 'OK'];
        // }

        // private function error($apiMethod, Exception $exception)
        // {
            // \cli\err($apiMethod . ' - ERROR');
            // \cli\line((string)$exception);

            // $this->statuses[$apiMethod] = [$apiMethod, 'ERROR', $exception->getMessage()];

            // exit();
        // }

        // private function table(array $headers, array $rows = null, array $footer = null)
        // {
            // $table = new \cli\Table($headers, $rows, $footer);

            // $table->display();
        // }
    }
?>